
indexing
	description: "Main class for CGI version of Smalleiffel 'short' utility"
	project: "http://www.nenie.org/eiffel/"
	license: "http://www.opensource.org/licenses/mit-license.html"
	revision: "$Id: $"

class
	WEBSHORT

inherit
	SHORT
		redefine
			automat,
			argument_count, argument
		end

creation
	make

feature -- Hack to avoid error message
	
	argument_count: INTEGER is do Result := 1 end

	argument (i: INTEGER): STRING is do Result := "" end

feature {NONE}
	
	automat is
			-- Override ordinary command line argument parsing for a CGI 
			-- version ("name1=value1;name2=value2" in environment variable 
			-- QUERY_STRING).
			-- Switches have the same name as ordinary short and are enabled 
			-- with "switch=yes". The class name is in "class=X". The format 
			-- is hardcoded to "htmlcgi" (change below).
		local
			cgi: MINIMAL_CGI_QUERY
			has_error: BOOLEAN
		do
			format := "htmlcgi"
			root_class := ""

			!! cgi.make
			-- options
			if cgi.has_true_value ("sort") then
				sort := True
			end
			if cgi.has_true_value ("short") then
				short := True
			end
			if cgi.has_true_value ("case_insensitive") then
				eiffel_parser.set_case_insensitive
			end
			if cgi.has_true_value ("no_style_warning") then
				eiffel_parser.set_no_style_warning
			end
			if cgi.has_true_value ("no_warning") then
				eh.set_no_warning
			end

			-- class
			if cgi.has_value ("class") then
				root_class := cgi.value ("class")
				if as_bit_n_ref.same_as (root_class) then
					root_class := as_bit_n
				end
			end

			-- CGI header

			-- problem: In order to output the correct header type, html or plain 
			-- text we need to know if we'll get some HTML from the chosen format, 
			-- even if broken in the middle with an error (to display something the 
			-- html headers are enough) OR only a plain text error message.
			
			io.put_string ("Content-Type: text/html")
			io.put_new_line
			io.put_new_line
		end

end
